//------------------------------------------------------------------
//
// original described in "Random Walk Revealed" article
// TASC December 2011 by Rob Davis
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_level1  0
#property indicator_levelcolor DimGray
#property indicator_levelstyle STYLE_DASHDOTDOT

//
//
//
//
//

extern int    LookBack   =  80;
extern string UniqueID   = "DW2";
extern color  BackColor  = C'255,238,210';

//
//
//
//
//

double dwUp[];
double dwDn[];
double dsUp[];
double dsDn[];
string shortName;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   
   SetIndexBuffer(0,dwUp);
   SetIndexBuffer(1,dwDn);
   SetIndexBuffer(2,dsUp); SetIndexStyle(2,DRAW_SECTION);
   SetIndexBuffer(3,dsDn); SetIndexStyle(3,DRAW_SECTION);
      UniqueID  = StringTrimLeft(StringTrimRight(UniqueID));
      shortName = UniqueID+" Drunkard\'s walk ("+LookBack+")";
      IndicatorShortName(shortName);
   return (0);
}
int deinit() { ObjectDelete(UniqueID+"back"); return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][5];

int start()
{
   double alpha = 2.0 / (1.0+LookBack); 
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (UniqueID!="" && ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         
   //
   //
   //
   //
   //

      for(i = limit, r= Bars-i-1; i >= 0; i--, r++)
      {
         int    longMaxBar = iHighest(High,0,MODE_HIGH,LookBack,i);
         int    longMinBar = iLowest(Low,0,MODE_LOW,LookBack,i);
         int    longDnRun  = longMaxBar-i;
         int    longUpRun  = longMinBar-i;
         double longHigh   = High[longMaxBar];
         double longLow    = Low[longMinBar];

         //
         //
         //
         //
         //
                  
         work[r][1] = work[r-2][1]+1;
         work[r][2] = work[r-1][2];
         work[r][3] = work[r-1][3];
         work[r][4] = work[r-1][4];
            if (work[r][3]==0) 
            {
               work[r][1] = LookBack;
               work[r][2] = LookBack;
               work[r][3] = LookBack;
            }
            if (work[r-1][4]!=work[r-2][4])
            {
               work[r][1] = 1;
               work[r][2] = work[r-1][1];
               work[r][3] = work[r-1][3]+alpha*(work[r-1][2]-work[r-1][3]);
            }
                     
         //
         //
         //
         //
         //
         
         dsUp[i] = EMPTY_VALUE;
         dsDn[i] = EMPTY_VALUE;
         dwUp[i] = dwUp[i+1];
         dwDn[i] = dwDn[i+1];
            if (longDnRun > 0 && longUpRun > 0)
            {
               double denom = 1;
               double atrU = iATR(NULL,0,work[r][3],i); if(atrU > 0) denom = atrU; else denom = 1;
                  dwUp[i] = (High[i]-longLow)/(MathSqrt(work[r][3])*denom);
               double atrD = iATR(NULL,0,work[r][3],i); if(atrD > 0) denom = atrD; else denom = 1;
                  dwDn[i] = (longHigh -Low[i])/(MathSqrt(work[r][3])*denom);
            }            
            if (dwUp[i]>dwDn[i]) { dsUp[i] = -dwDn[i]; work[r][4] =  1; }
            if (dwUp[i]<dwDn[i]) { dsDn[i] = -dwUp[i]; work[r][4] = -1; }
            work[r][0] = MathMin(work[r-1][0],MathMin(dsUp[i],dsDn[i]));
      }
      
      //
      //
      //
      //
      //

      if (UniqueID!="")
      {
         string name = UniqueID+"back";
            ObjectCreate(name,OBJ_RECTANGLE,WindowFind(shortName),0,0,0,0);
               ObjectSet(name,OBJPROP_PRICE1,0);
               ObjectSet(name,OBJPROP_PRICE2,work[Bars-1][0]);
               ObjectSet(name,OBJPROP_TIME1,Time[Bars-1]);
               ObjectSet(name,OBJPROP_TIME2,Time[0]);
               ObjectSet(name,OBJPROP_BACK,true);
               ObjectSet(name,OBJPROP_COLOR,BackColor);
      }               
      return(0);
}